<?php

/**
 * cuenta actions.
 *
 * @package    controlComisiones
 * @subpackage cuenta
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cuentaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_CUENTA_V',
        'COM_RESOLUCION',
        'COM_COMISION',
        'PROYECTOS',
        'COM_TERCERO',
        'TIPOS_COMISION'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'COM_CUENTA_V'
        ),
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_CUENTA_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'id_cuenta',
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'id_anhos' => 'id_anhos',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'observaciones' => 'observaciones',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'valor' => 'valor',
            'no_caja' => 'no_caja'
        ),
        'COM_RESOLUCION' =>
        array(
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos_resol',
            'estado' => 'estado_resol'
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_fin' => 'fecha_fin',
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'codigo_cm', 'no_cuenta', 'no_caja'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_CUENTA_V' =>
        array(
            'id_cuenta,a' => array('!=' => array(-1)),
            'id_cuenta,b' => array('=' => array('id_cuenta')),
            'id_resolucion' => array('=' => array('id_resolucion')),
            'no_cuenta' => array('=' => array('no_cuenta')),
            'fecha_cuenta' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_tercero' => array('=' => array('id_mae_ter')),
            'no_caja' => array('=' => array('no_caja')),
            'estado' => array('=' => array('estado')),
            'id_anhos' => array('=' => array('id_anhos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow')),
        ),
        'COM_RESOLUCION' =>
        array(
            'no_resolucion' => array('=' => array('no_resolucion')),
        ),
        'PROYECTOS' =>
        array(
            'id' => array('=' => array('id_proyecto')),
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => array('=' => array('no_comision')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_cuenta'; //identificador de la tabla
    protected $id_names = array('id_cuenta'); //llave primaria
    protected $field_names = array('id_resolucion', 'no_cuenta', 'fecha_cuenta', 'estado', 'id_tercero', 'observaciones', 'id_anhos', 'fecha_anulacion', 'motivo_anulacion', 'no_caja'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_CUENTA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_cuenta'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $id_cuenta = $list_data_post[0]['id_cuenta'];
                $id_resolucion = $list_data_post[0]['id_resolucion'];
                $id_anhos = $list_data_post[0]['id_anhos'];
                $id_tercero = $list_data_post[0]['id_tercero'];


                $sql = <<<EOD
select * from com_resolucion where id_resolucion = $id_resolucion 
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_comision = $records[0]['id_comision'];

                $sql = <<<EOD
select * from com_comision where id_comision = $id_comision
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_proyecto = $records[0]['id_proyecto'];


                $sql = <<<EOD
select id_obj_gasto,sum(valor) valor 
    from com_comisionado_obj 
        where id_comision = $id_comision and id_tercero= $id_tercero 
    group by id_obj_gasto
EOD;

                $records = CN_TABLE::executeSQL($sql);

                foreach ($records as $valores) {

                    $id_obj_gasto = $valores['id_obj_gasto'];
                    $valor = $valores['valor'];

                    $sql = <<<EOD
select * from com_detalle_presup where id_obj_gasto = $id_obj_gasto and id_proyecto = $id_proyecto and id_anhos='$id_anhos'
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $id_rubro = $records[0]['id_rubro'];

                    $sql = <<<EOD
            INSERT INTO COM_DETA_CUENTA (ID_CUENTA,ID_PROYECTO,ID_RUBRO,ID_OBJ_GASTO,VALOR_CUENTA)
               VALUES($id_cuenta,$id_proyecto,$id_rubro,$id_obj_gasto,$valor)
EOD;

                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['id_anhos'] = $id_anhos;

            $sql = <<<EOD
select consecutivo from com_consecutivo_cuenta where id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {

                $consecutivo = $records[0]['consecutivo'];

                $request['no_cuenta'] = $consecutivo;

                $sql = <<<EOD
update com_consecutivo_cuenta set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

            }else{
                $consecutivo = 1;

                $request['no_cuenta'] = $consecutivo;

                $sql = <<<EOD
Insert into com_consecutivo_cuenta (ID_CONSECUTIVO_CUENTA,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;
                        
            }
            
            $request['estado'] = 1;
            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_tercero = $request['id_tercero'];
        $id_resolucion = $request['id_resolucion'];



        $sql = <<<EOD
select * from com_resolucion where id_resolucion = $id_resolucion
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_comision = $records[0]['id_comision'];
        $id_anhos = $records[0]['id_anhos'];


        $sql = <<<EOD
select count(id_comisionado) cantidad from com_comisionado where id_comision = $id_comision and id_tercero=$id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];



        if ($cantidad == 0) {

            $errors['mensaje'] = "El Comisionado no se encuentra programado para esta comision";
            $errors['servicio'] = "cuenta";
        }

        $id_cuenta = $request['id_cuenta'];

        $sql = <<<EOD
select count(id_cuenta) cantidad from com_cuenta_v where id_resolucion = $id_resolucion and id_tercero = $id_tercero and estado = 1
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Ya existe una cuenta asociada a esta comisionado. Favor verificar";
            $errors['servicio'] = "pago_egreso";
        }



        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_cuenta = $request['id_cuenta'];
        $anular = $request['anular'];

        if ($anular == true || $anular == "true" || $anular == 1 || $anular == "1") {

            $sql = <<<EOD
select count(id_pago_egreso) cantidad from com_pago_egreso where id_cuenta = $id_cuenta and estado = 1
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];

            if ($cantidad > 0) {

                $errors['mensaje'] = "Existen pagos asociados a esta cuenta, no se puede anular.";
                $errors['servicio'] = "cuenta";
            }
            /*
             *  Validar la operación, ya sea por SQL
             */

            /*
             *  Generar errores en $errors
             */
        }
        return $errors;
    }

}
